#include <vector>
#include <string>
#include <fstream>
#include <sstream>
#include <locale>
#include <memory.h>
#include <windows.h>

// t@C
#define MAKOTO_CONF	"makoto_conf.txt"
#define SAKURA_LIST	"makoto0.lst"
#define UNYUU_LIST	"makoto1.lst"
//
#define LIST_HEADER		L"[SAKURA]"
#define MAKOTO_HEADER	L"MAKOTO/2.0"
#define GET				L"GET"
#define VERSION			L"Version"
#define TRANSLATE		L"TRANSLATE"
#define SENTENCE		L"Sentence"
#define EXEC			L"EXECUTE"
#define CRLF			L"\x0D\x0A"
#define GETVERSION		GET L" " VERSION L" " MAKOTO_HEADER
#define TRANSLATESENTENCE TRANSLATE L" " SENTENCE L" " MAKOTO_HEADER
#define EXECUTE			EXEC L" " MAKOTO_HEADER
#define ERR_MES		MAKOTO_HEADER L" 400 Bad Request" CRLF CRLF
#define RES_MES_OK	MAKOTO_HEADER L" 200 OK" CRLF
#define RES_MES_NO	MAKOTO_HEADER L" 204 No Content" CRLF

std::vector<std::wstring>	*before[2],*after[2];
std::wstring lang;

typedef enum _CharSet{SJIS,JIS,EUCJP,UTF8,UTF8N,Unicode} CharSet;
CharSet charset;

inline UINT codepage(CharSet c){
	switch(c){
		case SJIS:
			return 932U;
		case UTF8N:
			return CP_UTF8;
	}
	return CP_ACP;
}

// Cӂ̃}`oCgR[hɕϊ
void conv_to_multi(const std::wstring &from,std::string &to,CharSet c){
	UINT cp = codepage(c);
	int len = WideCharToMultiByte(cp,0,from.c_str(),-1,NULL,0,NULL,NULL);
	char *buf = new char[len+1];
	memset(buf,'\0',(len+1)*sizeof(char));
	WideCharToMultiByte(cp,0,from.c_str(),-1,buf,len,NULL,NULL);
	to.assign(buf);
	delete [] buf;
	return;
}
//Cӂ̃}`oCgR[h烏Chɕϊ
void conv_to_wide(const std::string &from,std::wstring &to,CharSet c){
	UINT cp = codepage(c);
	int len = MultiByteToWideChar(cp,0,from.c_str(),-1,NULL,0);
	/*if(len == 0){
		char a[20];
		_itoa_s(GetLastError(),a,16);
		MessageBox(0,a,"",0);
	}*/
	wchar_t *buf = new wchar_t[len+1];
	memset(buf,'\0',(len+1)*sizeof(wchar_t));
	len = MultiByteToWideChar(cp,0,from.c_str(),-1,buf,len);
	/*if(len == 0){
		char a[20];
		_itoa_s(GetLastError(),a,16);
		MessageBox(0,a,"",0);
	}*/
	to.assign(buf);
	delete [] buf;
	return;
}

extern "C" __declspec(dllexport) BOOL __cdecl load(HGLOBAL h, long len){
	before[0] = new std::vector<std::wstring>();
	after[0] = new std::vector<std::wstring>();
	before[1] = new std::vector<std::wstring>();
	after[1] = new std::vector<std::wstring>();
		
	std::string path;
	std::string fullpath;
	fullpath.reserve(MAX_PATH);
	
	path.resize(len,'\0');
	memmove((void*)path.c_str(),(void*)h,len);
	//path.assign((char*)h,len);
	GlobalFree(h);
	//MessageBox(0,path.c_str(),"",0);

	// RtBOǂݍ
	//ftHgl
	charset = UTF8N;
	lang.assign(L"Japanese");
	// svH
	std::locale::global(std::locale("japanese"));

	fullpath.assign(path);
	fullpath.append(MAKOTO_CONF);
	std::ifstream conf(fullpath.c_str());
	//MessageBox(0,fullpath.c_str(),"",0);
	
	if(conf.is_open()){
		//MessageBox(0,fullpath.c_str(),"",0);
		std::string line;
		while(std::getline(conf,line)){
			if(line.empty())
				continue;
			size_t index = line.find_first_of(',');
			if(index == std::wstring::npos)
				continue;
			if(line.compare(0,index,"Charset")==0){
				std::string cs = line.substr(index+1);
				if(cs.compare("Shift_JIS")==0){
					charset = SJIS;
				}else if(cs.compare("UTF-8N")==0){
					charset = UTF8N;
				}else{
					charset = UTF8N;
				}
			}else if(line.compare(0,index,"Language")==0){
				// svH
				std::locale::global(std::locale(line.substr(index+1).c_str()));
				conv_to_wide(line.substr(index+1),lang,SJIS);
			}
		}
	}
	//MessageBoxW(0,lang.c_str(),L"",0);
	// ϊ[ǂݍ
	std::string buf;
	std::wstring wbuf;
	
	for(int i=0;i<2;i++){
		fullpath.assign(path);		
		if(i==0){
			fullpath.append(SAKURA_LIST);
		}else{
			fullpath.append(UNYUU_LIST);
		}
		//MessageBox(0,fullpath.c_str(),"",0);

		std::ifstream ifs(fullpath.c_str());
		if(!ifs.is_open())
			continue;

		std::getline(ifs,buf);
		//MessageBox(0,buf.c_str(),"",0);
		conv_to_wide(buf,wbuf,charset);
		
		//MessageBoxW(0,wbuf.c_str(),L"",0);
		
		if(wbuf.compare(LIST_HEADER)==0){
			while(std::getline(ifs,buf)){
				//MessageBox(0,buf.c_str(),"",0);
				conv_to_wide(buf,wbuf,charset);
				//MessageBoxW(0,wbuf.c_str(),L"",0);
				if(wbuf.compare(L"")==0)
					continue;
				size_t index = wbuf.find_first_of(L',');
				if(index == std::wstring::npos)
					continue;
				//MessageBoxW(0,wbuf.substr(0,index).c_str(),wbuf.substr(index+1).c_str(),0);
				before[i]->push_back(wbuf.substr(0,index));
				after[i]->push_back(wbuf.substr(index+1));			
			}
		}
	}
	//MessageBoxW(0,before[0]->at(0).c_str(),L"",0);
	return true;
}

extern "C" __declspec(dllexport) BOOL __cdecl unload(){
	delete after[0];
	delete before[0];
	delete after[1];
	delete before[1];
	after[0] = NULL;
	after[1] = NULL;
	before[0] = NULL;
	before[1] = NULL;

	return true;
}


// wstring烌X|X(HGLOBAL)𐶐
inline HGLOBAL set_return(std::wstring mes,long *len){
	HGLOBAL h;
	std::string res;
	//MessageBoxW(0,mes.c_str(),L"",0);
	conv_to_multi(mes,res,UTF8N);
	//*len = (long)wcslen(mes.c_str());
	*len = (long)res.size();
	h  = GlobalAlloc(GPTR,*len);
	//strcpy_s((char*)h,*len,res.c_str());
	memmove((void*)h,(void*)res.c_str(),*len);
	
	return h;
}
inline void int_mes(int i){
	char a[20];
	_itoa_s(i,a,10);
	MessageBox(0,a,"",0);
}

inline size_t pos_min(size_t x,size_t y){
	//int_mes(x);
	//int_mes(y);
	if(x == std::string::npos)
		return y;
	if(y == std::string::npos)
		return x;
	if(x < y)	return x;
	else		return y;
}


inline HGLOBAL translate(std::wstring &mes,long *len,wchar_t *ret_name){
	int character = 0;
	bool replaced = false;
	size_t index = 0,next,sakura_pos,unyuu_pos;
	std::wstring res,buf;
	res.reserve(mes.size()*2);

	//todo:GXP[v^O΍
	sakura_pos=pos_min(mes.find(L"\\0",index),mes.find(L"\\h",index));
	unyuu_pos =pos_min(mes.find(L"\\1",index),mes.find(L"\\u",index));
	index = pos_min(sakura_pos,unyuu_pos);
	if(index != std::wstring::npos || index != 0)
		res.assign(mes,0,index);
	/*int_mes(index);
	int_mes(sakura_pos);
	int_mes(unyuu_pos);
	
	MessageBoxW(0,mes.c_str(),L"\\0",0);*/
	
	while(index != std::wstring::npos){
		if(index == sakura_pos){
			character = 0;
			sakura_pos=pos_min(mes.find(L"\\0",index+2),mes.find(L"\\h",index+2));
		}else{// if(index == unyuu_pos)
			character = 1;
			unyuu_pos =pos_min(mes.find(L"\\1",index+2),mes.find(L"\\u",index+2));
		}
		next = pos_min(sakura_pos,unyuu_pos);
		
		/*int_mes(next);
		int_mes(sakura_pos);
		int_mes(unyuu_pos);*/
		
		if(next == std::wstring::npos)
			//next = mes.size()-1;
			buf = mes.substr(index,next);
		else
			buf = mes.substr(index,next-index);
		
		//MessageBoxW(0,buf.c_str(),L"",0);
		////replace璷Ȃ邩Ȃ̂
		buf.reserve(buf.size()*2);
		
		for(size_t i = 0; i < before[character]->size() ; i++){
			size_t buf_idx = buf.find_first_of(before[character]->at(i).c_str());
			//int_mes(buf_idx);
			while(buf_idx != std::wstring::npos){
				replaced = true;
				buf.replace(
					buf_idx,
					before[character]->at(i).size(),
					after[character]->at(i)
				);
				buf_idx = buf.find_first_of(
					before[character]->at(i),
					buf_idx + after[character]->at(i).size()
				);
			}
		}
		//MessageBoxW(0,buf.c_str(),L"",0);
		res.append(buf);
		index = next;
	}
	
	if(replaced){
		std::wstring ret;
		ret.reserve(wcslen(RES_MES_OK L"Charset: UTF-8" CRLF L": " CRLF CRLF)+res.size()+wcslen(ret_name));
		ret.assign(RES_MES_OK L"Charset: UTF-8" CRLF);
		ret.append(ret_name);
		ret.append(L": ");
		ret.append(res);
		ret.append(CRLF CRLF);
		return set_return(ret,len);
	}else{
		return set_return(RES_MES_NO L"Charset: UTF-8" CRLF CRLF,len);
	}
}


extern "C" __declspec(dllexport) HGLOBAL __cdecl request(HGLOBAL h, long *len){
	std::string req;
	std::wstring wreq;
	
	req.resize(*len,'\0');
	memmove((void*)req.c_str(),(void*)h,*len);
	//req.assign((char*)h,*len);
	GlobalFree(h);
	//MessageBox(0,req.c_str(),"",0);
	conv_to_wide(req,wreq,UTF8N);
	//MessageBoxW(0,wreq.c_str(),L"",0);
	std::wstringstream request(wreq);
	std::getline(request,wreq);
	
	/*MessageBoxW(0,wreq.c_str(),L"",0);
		char a[20];
		_itoa_s(wcslen(GETVERSION),a,16);
		MessageBox(0,a,"",0);*/
	if(wreq.compare(0,wcslen(EXECUTE),EXECUTE,wcslen(EXECUTE))==0){
		while(std::getline(request,wreq)){
			if(wreq.size() == 0) continue;
			size_t index = wreq.find_first_of(L": ");
			if(index == std::wstring::npos) continue;
			if(wreq.compare(0,index,L"String",wcslen(L"String"))==0)
				return translate(wreq.substr(index+2),len,L"String");
		}
	}else if(wreq.compare(0,wcslen(GETVERSION),GETVERSION,wcslen(GETVERSION))==0){
		return set_return(
			RES_MES_OK L"Charset: UTF-8" CRLF \
			L"Language: Japanese" CRLF CRLF,len
		);
	}else if(wreq.compare(0,wcslen(TRANSLATESENTENCE),TRANSLATESENTENCE,wcslen(TRANSLATESENTENCE))==0){
		while(std::getline(request,wreq)){
			if(wreq.size() == 0) continue;
			size_t index = wreq.find_first_of(L": ");
			if(index == std::wstring::npos) continue;
			if(wreq.compare(0,index,L"Sentence",wcslen(L"Sentence"))==0)
				return translate(wreq.substr(index+2),len,L"Sentence");
		}
	}

	// ܂ŗ̂̓G[
	return set_return(ERR_MES,len);
}